#include "PDLL.h"
#include <winalleg.h>
#include "../dll_shared.h"
#include "dll_common.h"
#include "Vectors.h"

#define PLAYER_GROUND	-0.70710678f

dll_imports_p	g_pImports = NULL;
dll_exports_p	g_pExports = NULL;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

bool g_bvKeys[7];
bool g_bRun = false;
int g_dwRunTime = 0;
bool g_bFloat = false;
int g_dwFloatTime = 0;

void cbKeyLeft(bool bUp, int dwKey)
{
	g_bvKeys[0] = !bUp;
	if(bUp)
	{
		g_bRun = false;
	}
	else
	{
		if(g_pImports->dwGameTime-g_dwRunTime <= 50)
		{
			g_bRun = true;
		}
		g_dwRunTime = g_pImports->dwGameTime;
	}
}

void cbKeyRight(bool bUp, int dwKey)
{
	g_bvKeys[1] = !bUp;
	if(bUp)
	{
		g_bRun = false;
	}
	else
	{
		if(g_pImports->dwGameTime-g_dwRunTime <= 50)
		{
			g_bRun = true;
		}
		g_dwRunTime = g_pImports->dwGameTime;
	}
}

void cbKeyUp(bool bUp, int dwKey)
{
	g_bvKeys[5] = g_bvKeys[2] = !bUp;
	if(bUp)
	{
		g_bFloat = false;
	}
	else
	{
		if(g_pImports->dwGameTime-g_dwFloatTime <= 50)
		{
			g_bFloat = true;
		}
		g_dwFloatTime = g_pImports->dwGameTime;
	}
}

void cbKeyDown(bool bUp, int dwKey)
{
	g_bvKeys[6] = g_bvKeys[3] = !bUp;
}

void cbKeyJump(bool bUp, int dwKey)
{
	g_bvKeys[4] = !bUp;
}

void cbPtcTouchKill(particle_s* pPtc, struct entity_s* pEnt, float* fvClip)
{
	particle_p pNP;
	for(int lp=0; lp<5; lp++)
	{
		pNP= g_pImports->m_CreateParticle();
		if(pNP)
		{
			pNP->bDraw = true;
			pNP->bGravity = true;
			pNP->bLarge = false;
			pNP->dwColor = makecol(255, rand()%256, 0);
			pNP->fvVel[0] = ((rand()%201)-100)/5.0f;
			pNP->fvVel[1] = ((rand()%201)-100)/5.0f;
			pNP->fvPos[0] = pPtc->fvPos[0];
			pNP->fvPos[1] = pPtc->fvPos[1];
			pNP->dwDeath = g_pImports->dwGameTime+100;
		}
	}

	g_pImports->m_DeleteParticle(pPtc);
}

void DrawPlayerPole(entity_p pEnt, BITMAP* pDest, int dwSX, int dwSY)
{
	player_data_p pData = (player_data_p)pEnt->pvData[0];

	Vec2Multiply(pData->sPole.fvDir, pData->fPolePos, pEnt->fvPos);
	Vec2Add(pEnt->fvPos, pData->sPole.fvStart, pEnt->fvPos);
	if(pData->sPole.pOwner)
		Vec2Add(pData->sPole.pOwner->fvPos, pEnt->fvPos, pEnt->fvPos);
	if(pData->bFlip)
	{
		pEnt->fvPos[0] += 14.0f;
	}
	else
	{
		pEnt->fvPos[0] -= 14.0f;
	}

	if(pData->bFlip)
		g_pImports->m_DrawSpriteHFlip(pDest, pData->pMainBmp, pEnt->fvPos[0]-20-dwSX, pEnt->fvPos[1]-30-dwSY);
	else
		g_pImports->m_DrawSprite(pDest, pData->pMainBmp, pEnt->fvPos[0]-28-dwSX, pEnt->fvPos[1]-30-dwSY);

	float fX = pEnt->fvPos[0];
	float fY = pEnt->fvPos[1]+16.0f;
	if(pData->bFlip)
		g_pImports->m_PivotSpriteVFlip(pDest, pData->pFootBmp, fX-dwSX-12+(!pData->bWalk  ||  pData->dwUpFoot?0:2), fY-dwSY-pData->fvFootPos[0], 6, 0, -64);
	else
		g_pImports->m_PivotSprite(pDest, pData->pFootBmp, fX-dwSX+12-(!pData->bWalk  ||  pData->dwUpFoot?0:2), fY-dwSY-pData->fvFootPos[0], 6, 8, -64);

	if(pData->bFlip)
		g_pImports->m_PivotSpriteVFlip(pDest, pData->pFootBmp, fX-dwSX-12+(pData->bWalk  &&  pData->dwUpFoot?2:0), fY-dwSY-pData->fvFootPos[1], 6, 0, -64);
	else
		g_pImports->m_PivotSprite(pDest, pData->pFootBmp, fX-dwSX+12-(pData->bWalk  &&  pData->dwUpFoot?2:0), fY-dwSY-pData->fvFootPos[1], 6, 8, -64);

	g_pImports->m_DrawSprite(pDest, pData->pShoulderBmp, pEnt->fvPos[0]-dwSX-4, pEnt->fvPos[1]-8-dwSY);

	if(pData->pWeapon)
	{
		if(pData->bFlip)
			g_pImports->m_PivotSpriteVFlip(pDest, pData->pWeapon->pBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, pData->pWeapon->dwvOffset[0], pData->pHandBmp->h-pData->pWeapon->dwvOffset[1], GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
		else
			g_pImports->m_PivotSprite(pDest, pData->pWeapon->pBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, pData->pWeapon->dwvOffset[0], pData->pWeapon->dwvOffset[1], GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
	}
	else
	{
		if(pData->bFlip)
			g_pImports->m_PivotSpriteVFlip(pDest, pData->pHandBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, 0, pData->pHandBmp->h, GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
		else
			g_pImports->m_PivotSprite(pDest, pData->pHandBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, 0, 0, GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
	}
}

void DrawPlayerGrab(entity_p pEnt, BITMAP* pDest, int dwSX, int dwSY)
{
	player_data_p pData = (player_data_p)pEnt->pvData[0];

	pEnt->fvPos[0] = pData->sGrab.fvStart[0];
	pEnt->fvPos[1] = pData->sGrab.fvStart[1];
	if(pData->sGrab.pOwner)
		Vec2Add(pData->sGrab.pOwner->fvPos, pEnt->fvPos, pEnt->fvPos);

	if(pData->bFlip)
		g_pImports->m_DrawSpriteHFlip(pDest, pData->pGrabHandBmp, pEnt->fvPos[0]-dwSX-3, pEnt->fvPos[1]-dwSY-3);
	else
		g_pImports->m_DrawSprite(pDest, pData->pGrabHandBmp, pEnt->fvPos[0]-dwSX-3, pEnt->fvPos[1]-dwSY-3);

	pEnt->fvPos[1] += 30.0f;
	if(pData->bFlip)
	{
		pEnt->fvPos[0] += 14.0f;
	}
	else
	{
		pEnt->fvPos[0] -= 14.0f;
	}

	if(pData->bFlip)
		g_pImports->m_DrawSpriteHFlip(pDest, pData->pMainBmp, pEnt->fvPos[0]-20-dwSX, pEnt->fvPos[1]-30-dwSY);
	else
		g_pImports->m_DrawSprite(pDest, pData->pMainBmp, pEnt->fvPos[0]-28-dwSX, pEnt->fvPos[1]-30-dwSY);

	float fX = pEnt->fvPos[0];
	float fY = pEnt->fvPos[1]+16.0f;
	if(pData->bFlip)
		g_pImports->m_PivotSpriteVFlip(pDest, pData->pFootBmp, fX-dwSX-12, fY-dwSY, 6, 0, -64);
	else
		g_pImports->m_PivotSprite(pDest, pData->pFootBmp, fX-dwSX+12, fY-dwSY, 6, 8, -64);

	g_pImports->m_DrawSprite(pDest, pData->pShoulderBmp, pEnt->fvPos[0]-dwSX-4, pEnt->fvPos[1]-8-dwSY);

	if(pData->pWeapon)
	{
		if(pData->bFlip)
			g_pImports->m_PivotSpriteVFlip(pDest, pData->pWeapon->pBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, pData->pWeapon->dwvOffset[0], pData->pHandBmp->h-pData->pWeapon->dwvOffset[1], GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
		else
			g_pImports->m_PivotSprite(pDest, pData->pWeapon->pBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, pData->pWeapon->dwvOffset[0], pData->pWeapon->dwvOffset[1], GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
	}
	else
	{
		if(pData->bFlip)
			g_pImports->m_PivotSpriteVFlip(pDest, pData->pHandBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, 0, pData->pHandBmp->h, GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
		else
			g_pImports->m_PivotSprite(pDest, pData->pHandBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, 0, 0, GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
	}
}

void DrawPlayer(entity_p pEnt, BITMAP* pDest, int dwSX, int dwSY)
{
	player_data_p pData = (player_data_p)pEnt->pvData[0];

	if(pData->bFlip)
		g_pImports->m_DrawSpriteHFlip(pDest, pData->pMainBmp, pEnt->fvPos[0]-20-dwSX, pEnt->fvPos[1]-30-dwSY);
	else
		g_pImports->m_DrawSprite(pDest, pData->pMainBmp, pEnt->fvPos[0]-28-dwSX, pEnt->fvPos[1]-30-dwSY);

	float fX = pEnt->fvPos[0]+pData->fvFootPos[0];
	float fY = pEnt->fvPos[1]+35.0f;
	float fvClip[2] = { 0.0f, -1.0f };
	g_pImports->m_TraceLine(pEnt->fvPos[0]+pData->fvFootPos[0], pEnt->fvPos[1]+15.0f, fX, fY, fvClip);
	if(pData->bFlip)
		g_pImports->m_PivotSpriteVFlip(pDest, pData->pFootBmp, fX-dwSX, fY-dwSY-(!pData->bWalk || pData->dwUpFoot?0:2), 6, 0, GB_Atan2(fvClip[0], -fvClip[1])+128);
	else
		g_pImports->m_PivotSprite(pDest, pData->pFootBmp, fX-dwSX, fY-dwSY-(!pData->bWalk || pData->dwUpFoot?0:2), 6, 8, GB_Atan2(fvClip[0], -fvClip[1]));

	fX = pEnt->fvPos[0]+pData->fvFootPos[1];
	fY = pEnt->fvPos[1]+35.0f;
	fvClip[0] = 0.0f;
	fvClip[1] = -1.0f;
	g_pImports->m_TraceLine(pEnt->fvPos[0]+pData->fvFootPos[1], pEnt->fvPos[1]+15.0f, fX, fY, fvClip);
	if(pData->bFlip)
		g_pImports->m_PivotSpriteVFlip(pDest, pData->pFootBmp, fX-dwSX, fY-dwSY-(pData->bWalk && pData->dwUpFoot?2:0), 6, 0, GB_Atan2(fvClip[0], -fvClip[1])+128);
	else
		g_pImports->m_PivotSprite(pDest, pData->pFootBmp, fX-dwSX, fY-dwSY-(pData->bWalk && pData->dwUpFoot?2:0), 6, 8, GB_Atan2(fvClip[0], -fvClip[1]));

	g_pImports->m_DrawSprite(pDest, pData->pShoulderBmp, pEnt->fvPos[0]-dwSX-4, pEnt->fvPos[1]-8-dwSY);

	if(pData->pWeapon)
	{
		if(pData->bFlip)
			g_pImports->m_PivotSpriteVFlip(pDest, pData->pWeapon->pBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, pData->pWeapon->dwvOffset[0], pData->pHandBmp->h+3-pData->pWeapon->dwvOffset[1], GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
		else
			g_pImports->m_PivotSprite(pDest, pData->pWeapon->pBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, pData->pWeapon->dwvOffset[0], pData->pWeapon->dwvOffset[1], GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
	}
	else
	{
		if(pData->bFlip)
			g_pImports->m_PivotSpriteVFlip(pDest, pData->pHandBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, 0, pData->pHandBmp->h, GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
		else
			g_pImports->m_PivotSprite(pDest, pData->pHandBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-5-dwSY, 0, 0, GB_Atan2(g_pImports->dwvMousePos[0]-400, 300-g_pImports->dwvMousePos[1])-64);
	}
}

void DoPlayerWeapons(entity_p pEnt, player_data_p pData, int dwTime)
{
	if(g_pImports->bvMouseButtons[0]  &&  pData->pWeapon  &&  pData->pWeapon->m_Fire  &&  pData->dwNextWeapFire <= dwTime)
	{
		float fvPos[2] = { pEnt->fvPos[0], pEnt->fvPos[1]-5 };
		float fvDir[2] = { g_pImports->dwvMousePos[0]-400.0f, g_pImports->dwvMousePos[1]-300.0f };
		Vec2Normalize(fvDir, fvDir);
		float fvPerp[2];
		Vec2Perp(fvDir, fvPerp);
		if(pData->bFlip)
			Vec2Invert(fvPerp, fvPerp);

		pData->dwNextWeapFire = pData->pWeapon->m_Fire(pData->pWeapon, pEnt, dwTime, pData->dwWeapPower, fvPos, fvDir, fvPerp);
	}
}

void RunPlayer(entity_p pEnt, int dwTime);

void RunPlayerPole(entity_p pEnt, int dwTime)
{
	player_data_p pData = (player_data_p)pEnt->pvData[0];

	float fMove = -pData->fPolePos;
	if(g_bvKeys[4])
	{
		g_bvKeys[4] = false;
		pEnt->m_Run = RunPlayer;
		pEnt->m_Draw = DrawPlayer;
		g_pImports->m_EntityMobile(pEnt);
		pEnt->fvVel[1] -= 200.0f;
	}
	if(g_bvKeys[5])
	{
		pData->fPolePos -= pData->sPole.fvDir[1]*0.5f;
		pData->fPolePos = MID(0.0f, pData->fPolePos, pData->sPole.fLength);
	}
	if(g_bvKeys[6])
	{
		pData->fPolePos += pData->sPole.fvDir[1];
		pData->fPolePos = MID(0.0f, pData->fPolePos, pData->sPole.fLength);
	}
	fMove += pData->fPolePos;
	if(pData->sPole.fvDir[1] < 0.0f)
	{
		if(fMove <= 0.0f)
			pData->bWalk = false;
		else
			pData->bWalk = true;
	}
	else
	{
		if(fMove >= 0.0f)
			pData->bWalk = false;
		else
			pData->bWalk = true;
	}

	Vec2Multiply(pData->sPole.fvDir, pData->fPolePos, pEnt->fvPos);
	Vec2Add(pEnt->fvPos, pData->sPole.fvStart, pEnt->fvPos);
	if(pData->sPole.pOwner)
		Vec2Add(pData->sPole.pOwner->fvPos, pEnt->fvPos, pEnt->fvPos);
	g_pImports->dwvScrollPos[0] = (g_pImports->dwvMousePos[0]-400)*0.25f+pEnt->fvPos[0]-400;
	g_pImports->dwvScrollPos[1] = (g_pImports->dwvMousePos[1]-300)*0.25f+pEnt->fvPos[1]-300;
	if(pData->bFlip)
	{
		pEnt->fvPos[0] += 14.0f;
	}
	else
	{
		pEnt->fvPos[0] -= 14.0f;
	}

	if(pData->bWalk)
	{
		pData->fvFootPos[pData->dwUpFoot] += fMove;
		pData->fvFootPos[1-pData->dwUpFoot] -= fMove;
		if(ABS(pData->fvFootPos[pData->dwUpFoot]) > 10.0f)
		{
			pData->dwUpFoot = 1-pData->dwUpFoot;
			pData->fvFootPos[0] = SGN(pData->fvFootPos[0])*10.0f;
			pData->fvFootPos[1] = SGN(pData->fvFootPos[1])*10.0f;
		}
	}

	if(g_pImports->dwvMousePos[0] < 400)
		pData->bFlip = true;
	else
		pData->bFlip = false;

	DoPlayerWeapons(pEnt, pData, dwTime);
}

void RunPlayerGrab(entity_p pEnt, int dwTime)
{
	player_data_p pData = (player_data_p)pEnt->pvData[0];

	g_pImports->dwvScrollPos[0] = (g_pImports->dwvMousePos[0]-400)*0.25f+pEnt->fvPos[0]-400;
	g_pImports->dwvScrollPos[1] = (g_pImports->dwvMousePos[1]-300)*0.25f+pEnt->fvPos[1]-300;

	if(g_bvKeys[4])
	{
		g_bvKeys[4] = false;
		pEnt->m_Run = RunPlayer;
		pEnt->m_Draw = DrawPlayer;
		g_pImports->m_EntityMobile(pEnt);
		pEnt->fvVel[1] -= 200.0f;
	}

	DoPlayerWeapons(pEnt, pData, dwTime);
}

void RunPlayer(entity_p pEnt, int dwTime)
{
	player_data_p pData = (player_data_p)pEnt->pvData[0];

	g_pImports->dwvScrollPos[0] = (g_pImports->dwvMousePos[0]-400)*0.25f+pEnt->fvPos[0]-400;
	g_pImports->dwvScrollPos[1] = (g_pImports->dwvMousePos[1]-300)*0.25f+pEnt->fvPos[1]-300;

	bool bRun = false;
	if(pEnt->fvGround[1] <= PLAYER_GROUND)
	{
		bRun = g_bRun;
		g_bFloat = false;
	}

	float fVel = 0.0f;
	if(g_bvKeys[0])
	{
		fVel -= bRun?200.0f:120.0f;
		if(pData->bFlip  &&  g_pImports->m_GetGrabAtPoint(pEnt->fvPos[0]-14.0f, pEnt->fvPos[1]-20.0f, 8.0f, false, true, &pData->sGrab))
		{
			pEnt->m_Run = RunPlayerGrab;
			pEnt->m_Draw = DrawPlayerGrab;
			pData->bFlip = true;
			g_pImports->m_EntityStatic(pEnt);
			pEnt->fvVel[0] = pEnt->fvVel[1] = 0.0f;
			pEnt->fvPos[0] = pData->sGrab.fvStart[0]+14.0f;
			pEnt->fvPos[1] = pData->sGrab.fvStart[1]+20.0f;
			return;
		}
	}
	if(g_bvKeys[1])
	{
		fVel += bRun?200.0f:120.0f;
		if(!pData->bFlip  &&  g_pImports->m_GetGrabAtPoint(pEnt->fvPos[0]+14.0f, pEnt->fvPos[1]-20.0f, 8.0f, true, false, &pData->sGrab))
		{
			pEnt->m_Run = RunPlayerGrab;
			pEnt->m_Draw = DrawPlayerGrab;
			pData->bFlip = false;
			g_pImports->m_EntityStatic(pEnt);
			pEnt->fvVel[0] = pEnt->fvVel[1] = 0.0f;
			pEnt->fvPos[0] = pData->sGrab.fvStart[0]-14.0f;
			pEnt->fvPos[1] = pData->sGrab.fvStart[1]+20.0f;
			return;
		}
	}
	if(g_bvKeys[2])
	{
		g_bvKeys[2] = false;

		entity_p pUEnt = g_pImports->m_FindEntityAtPoint(pEnt->fvPos[0], pEnt->fvPos[1]-16.0f, NULL);
		while(pUEnt)
		{
			if(pUEnt != pEnt  &&  pUEnt->m_Use)
			{
				pUEnt->m_Use(pUEnt, pEnt);
				pUEnt = NULL;
			}
			else
			{
				pUEnt = g_pImports->m_FindEntityAtPoint(pEnt->fvPos[0], pEnt->fvPos[1]-16.0f, pUEnt);
			}
		}
	}
	if(g_bvKeys[3])
	{
		g_bvKeys[3] = false;

		entity_p pUEnt = g_pImports->m_FindEntityAtPoint(pEnt->fvPos[0], pEnt->fvPos[1]+16.0f, NULL);
		while(pUEnt)
		{
			if(pUEnt != pEnt  &&  pUEnt->m_AltUse)
			{
				pUEnt->m_AltUse(pUEnt, pEnt);
				pUEnt = NULL;
			}
			else
			{
				pUEnt = g_pImports->m_FindEntityAtPoint(pEnt->fvPos[0], pEnt->fvPos[1]+16.0f, pUEnt);
			}
		}
	}
	if(g_bvKeys[4])
	{
		g_bvKeys[4] = false;
		if(pEnt->fvGround[1] <= PLAYER_GROUND)
		{
			pEnt->fvVel[1] -= 200.0f;
		}
	}
	if(g_bvKeys[5]  &&  !g_bFloat)
	{
		if(g_pImports->m_GetPoleAtPoint(pEnt->fvPos[0]+(pData->bFlip?-14:14), pEnt->fvPos[1], 8.0f, &pData->sPole))
		{
			pEnt->m_Run = RunPlayerPole;
			pEnt->m_Draw = DrawPlayerPole;
			pData->fPolePos = pData->sPole.fvDir[0]*(pEnt->fvPos[0]+(pData->bFlip?-14:14)-(pData->sPole.fvStart[0]+(pData->sPole.pOwner?pData->sPole.pOwner->fvPos[0]:0)))+pData->sPole.fvDir[1]*((pEnt->fvPos[1])-(pData->sPole.fvStart[1]+(pData->sPole.pOwner?pData->sPole.pOwner->fvPos[1]:0)));
			pData->fPolePos = MID(0.0f, pData->fPolePos, pData->sPole.fLength);
			g_pImports->m_EntityStatic(pEnt);
			pEnt->fvVel[0] = pEnt->fvVel[1] = 0.0f;
		}
	}
	if(g_bvKeys[6]  &&  !g_bFloat)
	{
		if(g_pImports->m_GetPoleAtPoint(pEnt->fvPos[0]+(pData->bFlip?-14:14), pEnt->fvPos[1], 8.0f, &pData->sPole))
		{
			pEnt->m_Run = RunPlayerPole;
			pEnt->m_Draw = DrawPlayerPole;
			pData->fPolePos = pData->sPole.fvDir[0]*(pEnt->fvPos[0]+(pData->bFlip?-14:14)-(pData->sPole.fvStart[0]+(pData->sPole.pOwner?pData->sPole.pOwner->fvPos[0]:0)))+pData->sPole.fvDir[1]*((pEnt->fvPos[1])-(pData->sPole.fvStart[1]+(pData->sPole.pOwner?pData->sPole.pOwner->fvPos[1]:0)));
			pData->fPolePos = MID(0.0f, pData->fPolePos, pData->sPole.fLength);
			g_pImports->m_EntityStatic(pEnt);
			pEnt->fvVel[0] = pEnt->fvVel[1] = 0.0f;
		}
	}

	if(fVel != 0.0f  &&  pEnt->fvGround[1] <= PLAYER_GROUND)
		pData->bWalk = true;
	else
		pData->bWalk = false;
	if(pData->bWalk)
	{
		pData->fvFootPos[pData->dwUpFoot] += pEnt->fvVel[0]*0.01f;
		pData->fvFootPos[1-pData->dwUpFoot] -= pEnt->fvVel[0]*0.01f;
		if(ABS(pData->fvFootPos[pData->dwUpFoot]) > 10.0f)
		{
			g_pImports->m_PlaySampleAtPoint(pData->pvStep[rand()%2], pEnt->fvPos[0]+pData->fvFootPos[pData->dwUpFoot], pEnt->fvPos[1]+24.0f, 0.25f, 1.5f, 128);
			pData->dwUpFoot = 1-pData->dwUpFoot;
			pData->fvFootPos[0] = SGN(pData->fvFootPos[0])*10.0f;
			pData->fvFootPos[1] = SGN(pData->fvFootPos[1])*10.0f;
		}
	}

	float fForce = (fVel-pEnt->fvVel[0])*10.0f;
	if(ABS(fForce) < 50.0f)
	{
		pEnt->fvVel[0] = fVel;
	}
	else
	{
		if(pEnt->fvGround[1] <= PLAYER_GROUND)
		{
			if(bRun)
				fForce = MID(-400.0f, fForce, 400.0f);
			else
				fForce = MID(-200.0f, fForce, 200.0f);
		}
		else
		{
			fForce = MID(-100.0f, fForce, 100.0f);
		}
		pEnt->fvForce[0] += fForce;
	}

	if(g_bFloat  &&  pData->pFlib)
	{
		pEnt->fvVel[1] = 20.0f;
	}
	if(pData->pFlibData)
		pData->pFlibData->bLift = g_bFloat;

	pData->fVel = fVel;
	if(g_pImports->dwvMousePos[0] < 400)
		pData->bFlip = true;
	else
		pData->bFlip = false;

	DoPlayerWeapons(pEnt, pData, dwTime);
}

entity_p SpawnPlayer(string sType, string sName, int dwvPos[], string svVars[])
{
	if(g_pImports->pPlayer)
		return NULL;

	entity_p pEnt = g_pImports->m_NewEntity();
	g_pImports->pPlayer = pEnt;

	pEnt->sName = sName;
	pEnt->sClass = sType;
	pEnt->fvPos[0] = (dwvPos[0]+dwvPos[2])>>1;
	pEnt->fvPos[1] = (dwvPos[1]+dwvPos[3])>>1;
	pEnt->fvVel[0] = 1.0f;
	pEnt->fvVel[1] = 0.0f;
	pEnt->fvSize[0] = 14.0f;
	pEnt->fvSize[1] = 24.0f;
	pEnt->bSolid = true;

/*	col_circle_t sCol;
	sCol.fRadius = 24.0f;
	sCol.fvOffset[0] = 0.0f;
	sCol.fvOffset[1] = 0.0f;
	g_pImports->m_EntityAddCollider(pEnt, sCol);*/

	player_data_p pData = new player_data_t;
	pEnt->pvData[0] = pData;
	pData->pMainBmp = g_pImports->m_LoadSprite("Player.bmp");
	pData->pFrontBmp = g_pImports->m_LoadSprite("PlayerF.bmp");
	pData->pFootBmp = g_pImports->m_LoadSprite("Shoe.bmp");
	pData->pHandBmp = g_pImports->m_LoadSprite("Arm.bmp");
	pData->pGrabHandBmp = g_pImports->m_LoadSprite("GrabHand.bmp");
	pData->pShoulderBmp = g_pImports->m_LoadSprite("Shoulder.bmp");
	pData->pvStep[0] = g_pImports->m_LoadSample("pl_step1");
	pData->pvStep[1] = g_pImports->m_LoadSample("pl_step2");
	pData->dwUpFoot = 0;
	pData->fvFootPos[0] = 0;
	pData->fvFootPos[1] = 0;
	pData->bWalk = false;
	pData->dwKeysHeld = 0;
	pData->pWeapon = NULL;
	pData->dwNextWeapAnim = 0;
	pData->dwNextWeapFire = 0;
	pData->dwWeapPower = 0;
	pData->pCloak = g_pImports->m_LoadRefractor("PlayerCloak.bmp");
	pData->pFlib = NULL;
	pData->pFlibData = NULL;
	pData->pWib = NULL;
	pData->pWibData = NULL;

	pEnt->m_Draw = DrawPlayer;
	pEnt->m_Run = RunPlayer;

	g_pImports->m_EntityVisible(pEnt);
	g_pImports->m_EntityMobile(pEnt);
	g_pImports->m_EntityActive(pEnt);
	g_pImports->m_EntitySolid(pEnt);

	g_pImports->pvKeyFuncs[KEY_LEFT] = cbKeyLeft;
	g_pImports->pvKeyFuncs[KEY_LEFT|0x80] = cbKeyLeft;
	g_pImports->pvKeyFuncs[KEY_RIGHT] = cbKeyRight;
	g_pImports->pvKeyFuncs[KEY_RIGHT|0x80] = cbKeyRight;
	g_pImports->pvKeyFuncs[KEY_A] = cbKeyLeft;
	g_pImports->pvKeyFuncs[KEY_A|0x80] = cbKeyLeft;
	g_pImports->pvKeyFuncs[KEY_D] = cbKeyRight;
	g_pImports->pvKeyFuncs[KEY_D|0x80] = cbKeyRight;
	g_pImports->pvKeyFuncs[KEY_UP] = cbKeyUp;
	g_pImports->pvKeyFuncs[KEY_UP|0x80] = cbKeyUp;
	g_pImports->pvKeyFuncs[KEY_W] = cbKeyUp;
	g_pImports->pvKeyFuncs[KEY_W|0x80] = cbKeyUp;
	g_pImports->pvKeyFuncs[KEY_DOWN] = cbKeyDown;
	g_pImports->pvKeyFuncs[KEY_DOWN|0x80] = cbKeyDown;
	g_pImports->pvKeyFuncs[KEY_S] = cbKeyDown;
	g_pImports->pvKeyFuncs[KEY_S|0x80] = cbKeyDown;
	g_pImports->pvKeyFuncs[KEY_LSHIFT] = cbKeyJump;
	g_pImports->pvKeyFuncs[KEY_LSHIFT|0x80] = cbKeyJump;
	g_pImports->pvKeyFuncs[KEY_RSHIFT] = cbKeyJump;
	g_pImports->pvKeyFuncs[KEY_RSHIFT|0x80] = cbKeyJump;

	for(int lp=0; lp<5; lp++)
		g_bvKeys[lp] = false;

	return pEnt;
}

void AttachWeaponToPlayer(entity_p pPlayer, player_weapon_p pWeapon)
{
	player_data_p pData = (player_data_p)pPlayer->pvData[0];

	if(!pData->pWeapon)
	{
		pData->pWeapon = pWeapon;
	}
	else if(!pData->pBackWeapon)
	{
		pData->pBackWeapon = pData->pWeapon;
		pData->pWeapon = pWeapon;
	}
	else
	{
	}
}

entity_p SpawnDripper(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnTriggerOnce(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnPathNode(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnElevator(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnDoor(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnReflection(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnFan(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnKey(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnLock(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnGravZone(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnRaygun(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnGrenadeLauncher(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnFlib(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnWib(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnShib(string sType, string sName, int dwvPos[], string svVars[]);
entity_p SpawnAcidFlask(string sType, string sName, int dwvPos[], string svVars[]);

PDLL_API dll_exports_p LoadGameDLL(dll_imports_p pImports)
{
	int lp;
	for(lp=0; lp<4; lp++)
		g_bvKeys[lp] = false;

	g_pImports = pImports;

	g_pExports = new dll_exports_t;

	g_pExports->szName = "Main DLL";
	g_pExports->udwVersion = MAKE_VER(0, 1, 'a');

	g_pImports->m_SetSpawnFunc("player_start", SpawnPlayer);
	g_pImports->m_SetSpawnFunc("water_drip", SpawnDripper);
	g_pImports->m_SetSpawnFunc("trigger_once", SpawnTriggerOnce);
	g_pImports->m_SetSpawnFunc("path_node", SpawnPathNode);
	g_pImports->m_SetSpawnFunc("elevator", SpawnElevator);
	g_pImports->m_SetSpawnFunc("door", SpawnDoor);
	g_pImports->m_SetSpawnFunc("reflection", SpawnReflection);
	g_pImports->m_SetSpawnFunc("fan", SpawnFan);
	g_pImports->m_SetSpawnFunc("item_key", SpawnKey);
	g_pImports->m_SetSpawnFunc("trigger_lock", SpawnLock);
	g_pImports->m_SetSpawnFunc("zone_gravity", SpawnGravZone);
	g_pImports->m_SetSpawnFunc("weapon_raygun", SpawnRaygun);
	g_pImports->m_SetSpawnFunc("weapon_grenade_launcher", SpawnGrenadeLauncher);
	g_pImports->m_SetSpawnFunc("item_flib", SpawnFlib);
	g_pImports->m_SetSpawnFunc("item_wib", SpawnWib);
	g_pImports->m_SetSpawnFunc("item_shib", SpawnShib);
	g_pImports->m_SetSpawnFunc("object_acid", SpawnAcidFlask);

	for(lp=0; lp<32; lp++)
		g_pvKeyBmp[lp] = NULL;

	g_pvKeyBmp[0] = g_pImports->m_LoadSprite("DiamondKey.bmp");
	g_pvKeyBmp[1] = g_pImports->m_LoadSprite("SquareKey.bmp");

	return g_pExports;
}

map_ent_type_t g_svMapEnts[] = {
	{ "player_start", { 32, 64 }, false, false, 0xFF0000, 0x000000 },
	{ "health_orb", { 18, 18 }, false, false, 0xFFFFFF, 0xFF0000, { "Amount" }, { "5" }, "Health.bmp" },
	{ "water_drip", { 9, 11 }, false, false, 0xFFFFFF, 0xFFFFFF, { "Delay", "Random" }, { "200", "200" }, "Drip.bmp" },
	{ "trigger_once", { 32, 32 }, true, true, 0x000000, 0xFFFFFF, { "%Trigger", "Value1", "Value2" }, { "", "", "" } },
	{ "trigger_multiple", { 32, 32 }, true, true, 0x000000, 0xFFFFFF, { "%Trigger", "Value1", "Value2", "Delay" }, { "", "", "", "100" } },
	{ "path_node", { 11, 11 }, false, false, 0x000000, 0xFFFFFF, { "%Path", "%Path2", "Speed", "Delay" }, { "", "", "1.0", "0" }, "PathNode.bmp" },
	{ "elevator", { 64, 16 }, false, false, 0x000000, 0x000000, { "%Start", "Speed", "Pole1", "Pole2", "Grabs" }, { "", "200.0", "", "", "" }, "Platform.bmp" },
	{ "door", { 48, 64 }, true, true, 0x000000, 0xFFFFFF, { "%Dest", "Level" }, { "", "" } },
	{ "reflection", { 16, 16 }, true, true, 0x000000, 0x7F7FFF, { "Dir" }, { "Up" } },
	{ "fan", { 18, 18 }, false, false, 0xFFFFFF, 0xFFFFFF, { "Speed" }, { "1.0" }, "Fan.bmp" },
	{ "item_key", { 34, 34 }, false, false, 0xFFFFFF, 0xFFFFFF, { "Number", "Global" }, { "0", "" }, "DiamondKey.bmp" },
	{ "trigger_lock", { 16, 16 }, true, false, 0x000000, 0xFFFFFF, { "%Trigger", "Value1", "Value2", "Number" }, { "", "", "", "0" } },
	{ "zone_gravity", { 16, 16 }, true, true, 0x000000, 0xBFBFFF, { "X", "Y" }, { "0", "0" } },
	{ "weapon_raygun", { 32, 24 }, false, false, 0xFFFF00, 0xBFBFFF, { NULL }, { NULL }, "itemRaygun.bmp" },
	{ "weapon_grenade_launcher", { 32, 24 }, false, false, 0xFFFF00, 0xBFBFFF, { NULL }, { NULL }, "itemGrenadeLauncher.bmp" },
	{ "item_flib", { 27, 27 }, false, false, 0xFFFF00, 0xFFBFBF, { "Global" }, { "" }, "Flib.bmp" },
	{ "item_wib", { 39, 27 }, false, false, 0xFFFF00, 0xFFBFBF, { "Global" }, { "" }, "Wib.bmp" },
	{ "item_shib", { 41, 35 }, false, false, 0xFFFF00, 0xFFBFBF, { "Global" }, { "" }, "Shib.bmp" },
	{ "object_acid", { 26, 34 }, false, false, 0xFFFF00, 0xFFFFFF, { NULL }, { NULL }, "AcidFlask.bmp" },
	{ NULL },
};

PDLL_API dll_edit_exports_p LoadEditDLL()
{
	dll_edit_exports_p pExport = new dll_edit_exports_t;

	pExport->szName = "Test game";

	map_ent_type_p pPos = g_svMapEnts;
	while(pPos->szName)
	{
		pExport->pMapEnts.push_back(pPos);

		pPos++;
	}

	return pExport;
}
