#include "PDLL.h"
#include "../dll_shared.h"
#include "dll_common.h"
#include "Vectors.h"

typedef struct dripper_data_s {
	BITMAP*					pDripBmp;
	int						dwRate;
	int						dwRandom;
	int						dwNextDrip;
} dripper_data_t, *dripper_data_p;

bool cbDripTouch(particle_s* pPtc, struct entity_s* pEnt, float* fvClip)
{
	particle_p pNP;
	for(int lp=0; lp<25; lp++)
	{
		pNP= g_pImports->m_CreateParticle();
		if(pNP)
		{
			float fvVel[2] = { ((rand()%201)-100)/2.0f, (rand()%201)/2.0f };
			fvVel[0] *= (fvVel[1]+50)/150.0f;

			pNP->bDraw = true;
			pNP->bGravity = false;
			pNP->bLarge = true;
			pNP->dwColor = makecol(0, 0, 255);
			pNP->fvVel[0] = fvClip[0]*fvVel[1]+fvClip[1]*fvVel[0];
			pNP->fvVel[1] = fvClip[1]*fvVel[1]-fvClip[0]*fvVel[0];
			pNP->fvPos[0] = pPtc->fvPos[0];
			pNP->fvPos[1] = pPtc->fvPos[1];
			pNP->dwDeath = g_pImports->dwGameTime+10+(rand()%20);
		}
	}

	g_pImports->m_DeleteParticle(pPtc);

	return true;
}

void RunDripper(entity_p pEnt, int dwTime)
{
	dripper_data_p pData = (dripper_data_p)pEnt->pvData[0];
	if(pData->dwNextDrip <= dwTime)
	{
		pData->dwNextDrip = g_pImports->dwGameTime+pData->dwRate+(rand()%(pData->dwRandom+1));

		particle_p pPtc= g_pImports->m_CreateParticle();
		if(pPtc)
		{
			pPtc->bDraw = true;
			pPtc->bGravity = true;
			pPtc->bLarge = false;
			pPtc->pBmp = pData->pDripBmp;
			pPtc->fvPos[0] = pEnt->fvPos[0];
			pPtc->fvPos[1] = pEnt->fvPos[1];
			pPtc->dwDeath = dwTime+800;
			pPtc->m_Touch = cbDripTouch;
		}
	}
}

void TriggerDripper(entity_p pEnt, entity_p pOther, string sV1, string sV2)
{
	dripper_data_p pData = (dripper_data_p)pEnt->pvData[0];

	pData->dwRate = atoi(sV1.c_str());
	pData->dwRandom = atoi(sV2.c_str());
	pData->dwNextDrip = g_pImports->dwGameTime+pData->dwRate+(rand()%(pData->dwRandom+1));
}

entity_p SpawnDripper(string sType, string sName, int dwvPos[], string svVars[])
{
	entity_p pEnt = g_pImports->m_NewEntity();

	pEnt->sName = sName;
	pEnt->sClass = sType;
	pEnt->fvPos[0] = (dwvPos[0]+dwvPos[2])>>1;
	pEnt->fvPos[1] = (dwvPos[1]+dwvPos[3])>>1;
	pEnt->fvVel[0] = 0.0f;
	pEnt->fvVel[1] = 0.0f;
	pEnt->fvSize[0] = 1.0f;
	pEnt->fvSize[1] = 1.0f;

	dripper_data_p pData = new dripper_data_t;
	pEnt->pvData[0] = pData;
	pData->pDripBmp = g_pImports->m_LoadSprite("Drip.bmp");
	pData->dwRate = atoi(svVars[0].c_str());
	pData->dwRandom = atoi(svVars[1].c_str());
	pData->dwNextDrip = g_pImports->dwGameTime+pData->dwRate+(rand()%(pData->dwRandom+1));

	pEnt->m_Run = RunDripper;
	pEnt->m_Trigger = TriggerDripper;

	g_pImports->m_EntityActive(pEnt);

	return pEnt;
}
