#include "PDLL.h"
#include "../dll_shared.h"
#include "dll_common.h"
#include "Vectors.h"

bool cbWibBulletTouch(particle_s* pPtc, struct entity_s* pEnt, float* fvClip)
{
	if(pEnt == g_pImports->pPlayer)
		return false;

	particle_p pNP;
	for(int lp=0; lp<15; lp++)
	{
		pNP= g_pImports->m_CreateParticle();
		if(pNP)
		{
			pNP->bDraw = true;
			pNP->bGravity = true;
			pNP->bLarge = true;
			pNP->dwColor = makecol(255, rand()%256, 0);
			pNP->fvVel[0] = ((rand()%201)-100)/5.0f;
			pNP->fvVel[1] = ((rand()%201)-100)/5.0f;
			pNP->fvPos[0] = pPtc->fvPos[0];
			pNP->fvPos[1] = pPtc->fvPos[1];
			pNP->dwDeath = g_pImports->dwGameTime+50+rand()%50;
		}
	}

	g_pImports->m_DeleteParticle(pPtc);

	return true;
}

void RunWib(entity_p pEnt, int dwTime)
{
	wib_data_p pData = (wib_data_p)pEnt->pvData[0];
	player_data_p pPData;
	if(pData->pMaster)
		pPData = (player_data_p)pData->pMaster->pvData[0];
	else
		pPData = NULL;

	float fvDiff[2];
	Vec2Add(pData->pMaster->fvPos, pData->fvDest, fvDiff);
	Vec2Subtract(fvDiff, pEnt->fvPos, fvDiff);
	Vec2AddMul(pEnt->fvPos, fvDiff, (Vec2LengthEx(fvDiff)<=400.0f)?0.02f:0.05f, pEnt->fvPos);

	if((rand()%800) == 0)
		pData->dwBlink = dwTime+10;

	if((rand()%400) == 0)
	{
		pData->fvDest[0] = ((rand()%31)-15)-40.0f;
		pData->fvDest[1] = (rand()%31)-40.0f;
	}

	if(pPData->bFlip)
		pData->fvDest[0] = ABS(pData->fvDest[0]);
	else
		pData->fvDest[0] = -ABS(pData->fvDest[0]);

	if(g_pImports->bvMouseButtons[0]  &&  g_pImports->dwGameTime >= pData->dwNextShot)
	{
		pData->dwNextShot = g_pImports->dwGameTime+50;

		float fvDir[2] = { (mouse_x+g_pImports->dwvScrollPos[0])-pEnt->fvPos[0], (mouse_y+g_pImports->dwvScrollPos[1])-pEnt->fvPos[1] };
		Vec2Normalize(fvDir, fvDir);
		float fvPerp[2] = { -fvDir[1], fvDir[0] };
		if(fvDir[0] < 0.0f)
			Vec2Invert(fvPerp, fvPerp);

		particle_p pPtc = g_pImports->m_CreateParticle();
		if(pPtc)
		{
			pPtc->bDraw = true;
			pPtc->dwDeath = dwTime+400;
			Vec2AddMul(pEnt->fvPos, fvDir, 12.0f, pPtc->fvPos);
			Vec2AddMul(pPtc->fvPos, fvPerp, 5.0f, pPtc->fvPos);
			Vec2Multiply(fvDir, 400.0f, pPtc->fvVel);
			pPtc->pBmp = g_pImports->m_LoadSprite("WibBullet.bmp");
			pPtc->fAngle = GB_Atan2(fvDir[0], -fvDir[1]);
			pPtc->m_Touch = cbWibBulletTouch;

//			g_pImports->m_PlaySampleAtPoint(pData->pShootSample, pPtc->fvPos[0], pPtc->fvPos[1], 0.5f, 2.5f, 192);
		}
	}
}

void PickupWib(entity_p pEnt, entity_p pPlayer)
{
	wib_data_p pData = (wib_data_p)pEnt->pvData[0];
	player_data_p pPData = (player_data_p)pPlayer->pvData[0];

	pData->pMaster = pPlayer;
	pData->fvDest[0] = -40.0f;
	pData->fvDest[1] = -40.0f;

	pPData->pWib = pEnt;
	pPData->pWibData = pData;

	pEnt->m_AltUse = NULL;
	pEnt->m_Run = RunWib;
	pEnt->bSolid = false;
	pEnt->fvGravityMultiplier[0] = 0.0f;
	pEnt->fvGravityMultiplier[1] = 0.0f;

	g_pImports->m_EntityActive(pEnt);
	g_pImports->m_EntityStatic(pEnt);

	if(!pData->sGlobal.empty())
		g_pImports->m_SetGlobalFloat(pData->sGlobal, 1.0f);
}

void DrawWib(entity_p pEnt, BITMAP* pDest, int dwSX, int dwSY)
{
	wib_data_p pData = (wib_data_p)pEnt->pvData[0];
	player_data_p pPData;
	if(pData->pMaster)
		pPData = (player_data_p)pData->pMaster->pvData[0];
	else
		pPData = NULL;

	if(pData->pMaster)
	{
		float fAngle = GB_Atan2((mouse_x+dwSX)-pEnt->fvPos[0], pEnt->fvPos[1]-(mouse_y+dwSY))-64.0f;

		if((mouse_x+dwSX) < pEnt->fvPos[0])
			g_pImports->m_RotateSpriteVFlip(pDest, pData->dwBlink>=g_pImports->dwGameTime?pData->pBlinkBmp:pData->pSideBmp, pEnt->fvPos[0]-12-dwSX, pEnt->fvPos[1]-12-dwSY, fAngle);
		else
			g_pImports->m_RotateSprite(pDest, pData->dwBlink>=g_pImports->dwGameTime?pData->pBlinkBmp:pData->pSideBmp, pEnt->fvPos[0]-12-dwSX, pEnt->fvPos[1]-12-dwSY, fAngle);

		g_pImports->m_DrawSprite(pDest, pData->pRocketBmp, pEnt->fvPos[0]-dwSX, pEnt->fvPos[1]-12-dwSY);
		g_pImports->m_DrawRefractor(pDest, pData->pRocketBlur, pEnt->fvPos[0]-4-dwSX, pEnt->fvPos[1]+9-dwSY, 1.0f/16.0f);
		g_pImports->m_DrawRefractor(pDest, pData->pRocketPulse, pEnt->fvPos[0]-4-dwSX, pEnt->fvPos[1]+9-dwSY+(g_pImports->dwGameTime%16), 1.0f/16.0f);
	}
	else
	{
		g_pImports->m_DrawSprite(pDest, pData->dwBlink>=g_pImports->dwGameTime?pData->pBlinkBmp:pData->pMainBmp, pEnt->fvPos[0]-12-dwSX, pEnt->fvPos[1]-12-dwSY);
	}
}

entity_p SpawnWib(string sType, string sName, int dwvPos[], string svVars[])
{
	entity_p pEnt = g_pImports->m_NewEntity();

	pEnt->sName = sName;
	pEnt->sClass = sType;
	pEnt->fvPos[0] = (dwvPos[0]+dwvPos[2])>>1;
	pEnt->fvPos[1] = (dwvPos[1]+dwvPos[3])>>1;
	pEnt->fvVel[0] = 0.0f;
	pEnt->fvVel[1] = 0.0f;
	pEnt->fvSize[0] = 12.0f;
	pEnt->fvSize[1] = 12.0f;
	pEnt->bSolid = true;

	wib_data_p pData = new wib_data_t;
	pEnt->pvData[0] = pData;
	pData->pMainBmp = g_pImports->m_LoadSprite("Wib.bmp");
	pData->pBlinkBmp = g_pImports->m_LoadSprite("WibBlink.bmp");
	pData->pSideBmp = g_pImports->m_LoadSprite("WibSide.bmp");
	pData->pRocketBmp = g_pImports->m_LoadSprite("WibRocket.bmp");
	pData->pRocketBlur = g_pImports->m_LoadRefractor("JetBlur.bmp");
	pData->pRocketPulse = g_pImports->m_LoadRefractor("JetPulse.bmp");
	pData->dwBlink = 0;
	pData->sGlobal = svVars[0];
	pData->pMaster = NULL;
	pData->dwNextShot = 0;

	pEnt->m_Draw = DrawWib;
	pEnt->m_AltUse = PickupWib;

	g_pImports->m_EntityVisible(pEnt);
	g_pImports->m_EntityMobile(pEnt);

	if(!svVars[0].empty()  &&  g_pImports->m_GetGlobalFloat(svVars[0]) > 0.0f)
	{
		pData->pMaster = g_pImports->pPlayer;
		player_data_p pPData = (player_data_p)g_pImports->pPlayer->pvData[0];

		pData->fvDest[0] = -40.0f;
		pData->fvDest[1] = -40.0f;

		pPData->pWib = pEnt;
		pPData->pWibData = pData;

		pEnt->m_AltUse = NULL;
		pEnt->m_Run = RunWib;
		pEnt->bSolid = false;
		pEnt->fvGravityMultiplier[0] = 0.0f;
		pEnt->fvGravityMultiplier[1] = 0.0f;

		g_pImports->m_EntityActive(pEnt);
		g_pImports->m_EntityStatic(pEnt);
	}

	return pEnt;
}
