#ifndef DLL_COMMON_H
#define DLL_COMMON_H

#define GB_Atan2(x, y) (atan2(float(x), float(y))*128.0f/3.1415926f)

inline void gb_fputs(string sBuff, PACKFILE* pFile)
{
	int dwSize = sBuff.size()+1;
	pack_fwrite(&dwSize, sizeof(int), pFile);
	pack_fwrite(sBuff.c_str(), dwSize, pFile);
}

inline void gb_fgets(string& sBuff, PACKFILE* pFile)
{
	char szBuff[256];
	int dwSize;
	pack_fread(&dwSize, sizeof(int), pFile);
	pack_fread(szBuff, dwSize, pFile);
	sBuff = szBuff;
}

typedef struct flib_data_s {
	string					sGlobal;
	int						dwBlink;

	BITMAP*					pMainBmp;
	BITMAP*					pBlinkBmp;
	BITMAP*					pFanBmp;

	entity_p				pMaster;
	float					fvDest[2];
	bool					bLift;
} flib_data_t, *flib_data_p;

typedef struct wib_data_s {
	string					sGlobal;
	int						dwBlink;
	int						dwNextShot;

	BITMAP*					pMainBmp;
	BITMAP*					pBlinkBmp;
	BITMAP*					pSideBmp;
	BITMAP*					pRocketBmp;
	refractor_p				pRocketBlur;
	refractor_p				pRocketPulse;

	entity_p				pMaster;
	float					fvDest[2];
} wib_data_t, *wib_data_p;

typedef struct shib_data_s {
	string					sGlobal;
	int						dwSheildPower;
	int						dwChargeTime;
	platform_p				pSheild[2];

	BITMAP*					pMainBmp;
	BITMAP*					pSideBmp[2];

	entity_p				pMaster;
	float					fvDest[2];
} shib_data_t, *shib_data_p;

typedef struct player_weapon_s {
	BITMAP*					pBmp;
	int						dwvOffset[2];
	void*					pvData[4];

	void					(*m_Attach)(player_weapon_s* pWeapon, entity_p pEnt, int dwTime);
	int						(*m_Fire)(player_weapon_s* pWeapon, entity_p pEnt, int dwTime, int dwPower, float fvPos[], float fvDir[], float fvPerp[]);
	int						(*m_Anim)(player_weapon_s* pWeapon, entity_p pEnt, int dwTime);
	void					(*m_Drop)(player_weapon_s* pWeapon, entity_p pEnt, int dwTime);
} player_weapon_t, *player_weapon_p;

typedef struct player_data_s {
	BITMAP*					pMainBmp;
	BITMAP*					pFrontBmp;
	BITMAP*					pFootBmp;
	BITMAP*					pHandBmp;
	BITMAP*					pGrabHandBmp;
	BITMAP*					pShoulderBmp;

	refractor_s*			pCloak;

	SAMPLE*					pvStep[2];

	float					fvFootPos[2];
	int						dwUpFoot;
	float					fVel;
	bool					bFlip;
	bool					bWalk;

	player_weapon_p			pWeapon;
	player_weapon_p			pBackWeapon;
	int						dwNextWeapAnim;
	int						dwNextWeapFire;
	int						dwWeapPower;

	pole_info_t				sPole;
	grab_info_t				sGrab;
	float					fPolePos;
	int						dwDelay;

	entity_p				pFlib;
	flib_data_p				pFlibData;
	entity_p				pWib;
	wib_data_p				pWibData;
	entity_p				pShib;
	shib_data_p				pShibData;

	unsigned int			dwKeysHeld;
} player_data_t, *player_data_p;

typedef struct trigger_data_s {
	string					sTrigger;
	string					sV1;
	string					sV2;
	int						dwTime;
	int						dwDelay;
} trigger_data_t, *trigger_data_p;

typedef struct path_data_s {
	string					sPath1;
	string					sPath2;
	float					fSpeed;
	int						dwDelay;
} path_data_t, *path_data_p;

extern BITMAP* g_pvKeyBmp[];

void AttachWeaponToPlayer(entity_p pPlayer, player_weapon_p pWeapon);

#endif // DLL_COMMON_H
