#ifndef ENTITY_H
#define ENTITY_H

#include "dll_shared.h"
#include "Collide.h"
#include <deque>
#include <list>

using namespace std;

typedef void (*think_func_p)(entity_p pEnt, int dwTime);

typedef struct entity_think_s {
	int						dwTime;
	entity_p				pEnt;
	think_func_p			pFunc;
} entity_think_t, *entity_think_p;

typedef deque<entity_think_t> entity_think_list_t;

typedef struct entity_state_s {
	entity_list_t			svEnts;
	entity_list_t			svVisible;
	entity_list_t			svActive;
	entity_list_t			svAnimated;
	entity_list_t			svMobile;
	entity_list_t			svSolid;
	entity_think_list_t		svThink;
	entity_think_list_t		svThinkTemp;
} entity_state_t, *entity_state_p;

void CreateEntityState();
entity_p NewEntity();
void EntityVisible(entity_p pEnt);
void EntityInvisible(entity_p pEnt);
void EntityActive(entity_p pEnt);
void EntityInactive(entity_p pEnt);
void EntityAnimated(entity_p pEnt);
void EntityInanimate(entity_p pEnt);
void EntityMobile(entity_p pEnt);
void EntityStatic(entity_p pEnt);
void EntitySolid(entity_p pEnt);
void EntityNonsolid(entity_p pEnt);
void DrawEntities(BITMAP* pBmp, int dwX, int dwY);
void MoveEntities(collision_quadmap_p pMap);
void RunEntities(int dwTime);
void LoadEntities(spawn_func_list_t& pvSpawnFuncs, string sDir);
void RunTriggers(entity_p pPlayer);
trigger_zone_p AddTrigger();
entity_p FindEntityByName(string sName, entity_p pStart);
entity_p FindEntityAtPoint(float fX, float fY, entity_p pStart);
entity_p FindEntityInBox(float fX1, float fY1, float fX2, float fY2, entity_p pStart);
void ClearEntities(entity_p pPlayer);

#endif // ENTITY_H
