#include <allegro.h>
#include <winalleg.h>
#include "Globals.h"
#include <algorithm>

using namespace std;

global_string_list_t g_svGlobals;
global_number_list_t g_fvGlobals;

void ClearGlobals()
{
	g_svGlobals.clear();
	g_fvGlobals.clear();
}

void SetGlobalString(const string sName, const string sValue)
{
	g_svGlobals[sName] = sValue;
}

string GetGlobalString(const string sName)
{
	return g_svGlobals[sName];
}

void SetGlobalFloat(const string sName, const float fValue)
{
	g_fvGlobals[sName] = fValue;
}

float GetGlobalFloat(const string sName)
{
	return g_fvGlobals[sName];
}

void AddGlobalStringCallback(string sName, glob_string_callback_func_t pFunc, void* pData)
{
	glob_string_callback_t sCB = { pFunc, pData };
	g_svGlobals[sName].svCallbacks.push_back(sCB);
}

void RemoveGlobalStringCallback(string sName, glob_string_callback_func_t pFunc, void* pData)
{
	glob_string_callback_t sCB = { pFunc, pData };
	glob_string_p pS = &g_svGlobals[sName];
	pS->svCallbacks.erase(remove(pS->svCallbacks.begin(), pS->svCallbacks.end(), sCB), pS->svCallbacks.end());
}

void AddGlobalFloatCallback(string sName, glob_float_callback_func_t pFunc, void* pData)
{
	glob_float_callback_t sCB = { pFunc, pData };
	g_fvGlobals[sName].svCallbacks.push_back(sCB);
}

void RemoveGlobalFloatCallback(string sName, glob_float_callback_func_t pFunc, void* pData)
{
	glob_float_callback_t sCB = { pFunc, pData };
	glob_float_p pS = &g_fvGlobals[sName];
	pS->svCallbacks.erase(remove(pS->svCallbacks.begin(), pS->svCallbacks.end(), sCB), pS->svCallbacks.end());
}
