#include <allegro.h>
#include <winalleg.h>
#include "bmpmanager.h" // class's header file
#include <string>
#include <vector>

using namespace std;

CBmpManager::CBmpManager()
{
}

CBmpManager::~CBmpManager()
{
    char szBuff[256];
    PACKFILE* pFile = pack_fopen("LeakBmps.log", "w");
    for(vector<gb_bitmap_p>::iterator iPos=pvBmps.begin(); iPos!=pvBmps.end(); ++iPos)
    {
        if((*iPos) && (*iPos)->pBmp)
        {
            sprintf(szBuff, "%s %dx%d\n", (*iPos)->sName.c_str(), (*iPos)->pBmp->w, (*iPos)->pBmp->h);
            pack_fputs(szBuff, pFile);
            if(!((*iPos)->bDatBmp))
                destroy_bitmap((*iPos)->pBmp);
        }
    }
    pack_fclose(pFile);

    pvBmps.clear();
}

BITMAP** CBmpManager::GetBmp(string sName)
{
    if(sName.empty())
        return NULL;

    for(vector<gb_bitmap_p>::iterator iPos=pvBmps.begin(); iPos!=pvBmps.end(); ++iPos)
    {
        if((*iPos)->sName==sName)
        {
            (*iPos)->dwCount++;
            return &(*iPos)->pBmp;
        }
    }
    
    BITMAP* pBmp=load_bmp(sName.c_str(), NULL);
    if(!pBmp)
        return NULL;

    gb_bitmap_p pNBmp = new gb_bitmap_t;
    pNBmp->sName=sName;
    pNBmp->pBmp=pBmp;
    pNBmp->dwCount=1;
    pNBmp->bDatBmp=false;

    pvBmps.push_back(pNBmp);

    return &pNBmp->pBmp;
}

BITMAP** CBmpManager::GetBmp(BITMAP* pBmp)
{
    if(!pBmp)
        return NULL;

    for(vector<gb_bitmap_p>::iterator iPos=pvBmps.begin(); iPos!=pvBmps.end(); ++iPos)
    {
        if((*iPos)->pBmp==pBmp)
        {
            (*iPos)->dwCount++;
            return &(*iPos)->pBmp;
        }
    }

    gb_bitmap_p pNBmp = new gb_bitmap_t;
    pNBmp->sName="";
    pNBmp->pBmp=pBmp;
    pNBmp->dwCount=1;
    pNBmp->bDatBmp=false;

    pvBmps.push_back(pNBmp);

    return &pNBmp->pBmp;
}

BITMAP** CBmpManager::GetBmp(int dwIndex)
{
    if(dwIndex<0 || dwIndex>=int(pvBmps.size()))
        return NULL;

    return &pvBmps[dwIndex]->pBmp;
}


int CBmpManager::GetIndex(BITMAP* pBmp)
{
    if(!pBmp)
        return -1;

    int dwIndex = 0;
    for(vector<gb_bitmap_p>::iterator iPos=pvBmps.begin(); iPos!=pvBmps.end(); ++iPos)
    {
        if((*iPos)->pBmp==pBmp)
        {
            (*iPos)->dwCount++;
            return dwIndex;
        }
        dwIndex++;
    }

    return -1;
}

BITMAP** CBmpManager::DatFileBmp(string sName, BITMAP* pBmp)
{
    if(!pBmp)
        return NULL;

    for(vector<gb_bitmap_p>::iterator iPos=pvBmps.begin(); iPos!=pvBmps.end(); ++iPos)
    {
        if((*iPos)->pBmp==pBmp)
        {
            (*iPos)->dwCount++;
            return &(*iPos)->pBmp;
        }
    }

    gb_bitmap_p pNBmp = new gb_bitmap_t;
    pNBmp->sName=sName;
    pNBmp->pBmp=pBmp;
    pNBmp->dwCount=1;
    pNBmp->bDatBmp=true;

    pvBmps.push_back(pNBmp);

    return &pNBmp->pBmp;
}

void CBmpManager::ReleaseBmp(BITMAP* pBmp)
{
    if(!pBmp)
        return;

    for(vector<gb_bitmap_p>::iterator iPos=pvBmps.begin(); iPos!=pvBmps.end(); ++iPos)
    {
        if((*iPos)->pBmp==pBmp)
        {
            (*iPos)->dwCount--;
            if((*iPos)->dwCount<=0)
            {
                if((!(*iPos)->bDatBmp))
                    destroy_bitmap(pBmp);
                pvBmps.erase(iPos);
            }

            return;
        }
    }

    destroy_bitmap(pBmp);
}

void CBmpManager::Reload()
{
    for(vector<gb_bitmap_p>::iterator iPos=pvBmps.begin(); iPos!=pvBmps.end(); ++iPos)
    {
		if(!(*iPos)->bDatBmp)
		{
			destroy_bitmap((*iPos)->pBmp);

			(*iPos)->pBmp = load_bitmap((*iPos)->sName.c_str(), NULL);
		}
	}
}

CBmpManager *pBitmaps=NULL;

BITMAP** LoadBmp(string sName)
{
    if(!pBitmaps)
    {
        pBitmaps=new CBmpManager();
    }

    return pBitmaps->GetBmp(sName);
}

BITMAP** UseBmp(BITMAP* pBmp)
{
    if(!pBitmaps)
    {
        pBitmaps=new CBmpManager();
    }

    return pBitmaps->GetBmp(pBmp);
}

BITMAP** GetBmp(int dwIndex)
{
    if(!pBitmaps)
    {
        pBitmaps=new CBmpManager();
    }

    return pBitmaps->GetBmp(dwIndex);
}

int GetBmpIndex(BITMAP* pBmp)
{
    if(!pBitmaps)
    {
        pBitmaps=new CBmpManager();
    }

    return pBitmaps->GetIndex(pBmp);
}

BITMAP** RegisterBmp(string sName, BITMAP* pBmp)
{
    if(!pBitmaps)
    {
        pBitmaps=new CBmpManager();
    }

    return pBitmaps->DatFileBmp(sName, pBmp);
}

void ReleaseBmp(BITMAP* pBmp)
{
    if(!pBitmaps)
    {
        pBitmaps=new CBmpManager();
    }

    pBitmaps->ReleaseBmp(pBmp);
}

void DeleteBmpManager()
{
    if(pBitmaps)
        delete pBitmaps;
    pBitmaps=NULL;
}

void ReloadBmpManager()
{
	if(pBitmaps)
		pBitmaps->Reload();
}
