#ifndef BMPMANAGER_H
#define BMPMANAGER_H

#include <string>
#include <vector>

using namespace std;

typedef struct gb_bitmap_s {
    string                  sName;
    BITMAP*                 pBmp;
    int                     dwCount;
    bool                    bDatBmp;
} gb_bitmap_t, *gb_bitmap_p;

class CBmpManager
{
public:
                            CBmpManager();
                            ~CBmpManager();

    BITMAP**                GetBmp(string sName);
    BITMAP**                GetBmp(BITMAP* pBmp);
    BITMAP**                GetBmp(int dwIndex);
    int                     GetIndex(BITMAP* pBmp);
    BITMAP**                DatFileBmp(string sName, BITMAP* pBmp);
    void                    ReleaseBmp(BITMAP* pBmp);
	void					Reload();

protected:
    vector<gb_bitmap_p>     pvBmps;

};

BITMAP** LoadBmp(string sName);
BITMAP** UseBmp(BITMAP* pBmp);
BITMAP** GetBmp(int dwIndex);
int GetBmpIndex(BITMAP* pBmp);
BITMAP** RegisterBmp(string sName, BITMAP* pBmp);
void ReleaseBmp(BITMAP* pBmp);
void DeleteBmpManager();
void ReloadBmpManager();

#endif // BMPMANAGER_H

